/*****************************************************************************
* wanpipe_cfg_structs.h WANPIPE(tm) - Data structures for Sangoma MS Windows API.
*
* Author: 	David Rokhvarg <davidr@sangoma.com
*
* Copyright:	(c) 2007 Sangoma Technologies Inc.
*
* ============================================================================
* Nov 27, 2007  David Rokhvarg	Initial version
* ============================================================================
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
*/

#ifndef _WANPIPE_CFG_STRUCTS_H
#define _WANPIPE_CFG_STRUCTS_H

#if defined(_WANPIPE_CFG_H_)
enum DEVICE_CONFIGURATION_RETURN_CODE{

	DEVICE_CFG_OK = 1,
	DEVICE_CFG_FAILED_COMMS_ENABLED,
	DEVICE_CFG_FAILED_INVALID_LENGTH_OF_DATA_QUEUE,	//must be between MINIMUM_LENGTH_OF_DATA_QUEUE
													//and MAXIMUM_LENGTH_OF_DATA_QUEUE

	DEVICE_CFG_FAILED_INVALID_DATA_LENGTH,		//must be at least	MINIMUM_LENGTH_OF_DATA
	DEVICE_CFG_FAILED_MEMORY_ALLOCATION_ERR
};

typedef struct _DEVICE_CONFIGURATION
{
	u8 return_code;

	u16 maximum_length_of_rx_queue;
	u16 maximum_rx_data_length;		//including CRC bytes

	u16 maximum_length_of_tx_queue;
	u16 maximum_tx_data_length;		//not including CRC bytes

	/* Number of received blocks of data before Receive event is indicated to API caller. */
	u16 buffer_multiplier_factor;
}DEVICE_CONFIGURATION, *PDEVICE_CONFIGURATION;

#define MAXIMUM_PROTOCOL_LENGTH_OF_DATA	2048

#endif/* _WANPIPE_CFG_H_ */
#endif/* _WANPIPE_CFG_STRUCTS_H */
